unit Androidapi.JNI.Blong;

interface

uses
  Androidapi.JNIBridge,
  Androidapi.JNI.GraphicsContentViewText,
  Androidapi.JNI.Embarcadero;

type
// ===== Forward declarations =====

  JNativeActivitySubclass = interface;//com.blong.nfc.NativeActivitySubclass
  JBlongListener = interface;//com.blong.nfc.BlongListener

// ===== Interface declarations =====

  JNativeActivitySubclassClass = interface(JFMXNativeActivityClass)
    ['{829C77FB-08F1-4D19-9782-3C58EEC12599}']
    {class} function init: JNativeActivitySubclass; cdecl;
  end;

  [JavaSignature('com/blong/nfc/NativeActivitySubclass')]
  JNativeActivitySubclass = interface(JFMXNativeActivity)
    ['{3487ACB3-DC80-499E-B707-9F59E2BE92E9}']
    procedure setListener(listener: JBlongListener); cdecl;
    procedure enableNfcDetection; cdecl;
    procedure disableNfcDetection; cdecl;
  end;
  TJNativeActivitySubclass = class(TJavaGenericImport<JNativeActivitySubclassClass, JNativeActivitySubclass>) end;

  JBlongListenerClass = interface(IJavaClass)
    ['{168F8C7B-7FE9-4A08-87AD-51CCC3C56E43}']
  end;

  [JavaSignature('com/blong/nfc/BlongListener')]
  JBlongListener = interface(IJavaInstance)
    ['{D0E0FCFB-0400-4522-B51E-220FC79F92BB}']
    procedure onNewIntent(intent: JIntent); cdecl;
  end;
  TJBlongListener = class(TJavaGenericImport<JBlongListenerClass, JBlongListener>) end;

function BlongActivity: JNativeActivitySubclass;

implementation

uses
  Androidapi.NativeActivity,
  Androidapi.Helpers;

function BlongActivity: JNativeActivitySubclass;
begin
{$IF CompilerVersion >= 28}
  Result := TJNativeActivitySubclass.Wrap(SharedActivity);
{$ELSE}
  Result := TJNativeActivitySubclass.Wrap(PANativeActivity(System.DelphiActivity)^.clazz);
{$ENDIF}
end;

procedure RegisterTypes;
begin
  TRegTypes.RegisterType('Androidapi.JNI.Blong.JNativeActivitySubclass', TypeInfo(Androidapi.JNI.Blong.JNativeActivitySubclass));
  TRegTypes.RegisterType('Androidapi.JNI.Blong.JBlongListener', TypeInfo(Androidapi.JNI.Blong.JBlongListener));
end;

initialization
  RegisterTypes;
end.
